## clfft 2.12.2

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

if( WIN32 )
	# We require 2.8.3 for windows because of a bug in cmake that prevented vs2010 from generating
	# executables properly with multiple periods
	cmake_minimum_required( VERSION 2.8.3 )
else( )
	cmake_minimum_required( VERSION 2.6 )
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
	option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
	if( NMAKE_COMPILE_VERBOSE )
		set( CMAKE_START_TEMP_FILE "" )
		set( CMAKE_END_TEMP_FILE "" )
		set( CMAKE_VERBOSE_MAKEFILE 1 )
	endif( )
endif( )

# This becomes the name of the solution file
project( clFFT )

# Define a version for the code
if( NOT DEFINED CLFFT_VERSION_MAJOR )
	set( CLFFT_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED CLFFT_VERSION_MINOR )
	set( CLFFT_VERSION_MINOR 12 )
endif( )

if( NOT DEFINED CLFFT_VERSION_PATCH )
	set( CLFFT_VERSION_PATCH 2 )
endif( )

set( CLFFT_VERSION "${CLFFT_VERSION_MAJOR}.${CLFFT_VERSION_MINOR}.${CLFFT_VERSION_PATCH}")

# This is incremented when the ABI to the library changes
set( CLFFT_SOVERSION 2 )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files'
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT MSVC_IDE AND NOT CMAKE_BUILD_TYPE )
	set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE )
endif()

# Options that the user or driver program can set to control various components of the build
option( BUILD_RUNTIME "Build the FFT runtime library" ON )
option( BUILD_CLIENT "Build a command line clFFT client program with a variety of configurable parameters (dependency on Boost)" OFF )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and FFTW)" OFF )
option( BUILD_LOADLIBRARIES "Build the optional dynamic load libraries that the FFT runtime will search for" ON )
option( BUILD_SHARED_LIBS "Build shared libraries." ON )
option( BUILD_EXAMPLES "Build examples." ON )
option( BUILD_CALLBACK_CLIENT "Build a command line clFFT client program that tests callback functionality (dependency on Boost)" OFF )

# If BOOST_ROOT is defined as an environment value, use that value and cache it so it's visible in the cmake-gui.
# Otherwise, create a sensible default that the user can change
if( DEFINED ENV{BOOST_ROOT} )
	set( BOOST_ROOT $ENV{BOOST_ROOT} CACHE PATH "Environment variable defining the root of the Boost installation" )
endif( )

# Currently, linux has a problem outputing both narrow and wide characters,
# which happens in our client because openCL only supports narrow characters
if( WIN32 )
	option( UNICODE "Build with Unicode Support" ON )
	if( UNICODE )
		message( STATUS "UNICODE build" )
	endif( )
else( )
	set( UNICODE OFF )
	message( STATUS "UNICODE feature disabled on linux" )
endif()

if( MSVC_IDE )
	set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
	set( BUILD64 ${CMAKE_CL_64} )
else()
	option( BUILD64 "Build a 64-bit product" ON )

	if( IS_DIRECTORY ${PROJECT_SOURCE_DIR}/tests )
		option( CODE_COVERAGE "Build makefiles with code coverage instrumentation" OFF )
		if( CODE_COVERAGE )
			message( STATUS "Code coverage instrumentation on" )
		endif()
	endif()
endif()

# These variables are meant to contain string which should be appended to the installation paths
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

# Modify the global find property to help us find libraries like Boost in the correct paths for 64-bit
# Essentially, find_library calls will look for /lib64 instead of /lib; works for windows and linux
if( BUILD64 )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
	message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )
	if( NOT APPLE )
		set( SUFFIX_LIB_DEFAULT "64" )
	endif()
else( )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
	message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
endif( )

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

# Useful variables to configure FindBoost.cake
# set( Boost_USE_MULTITHREADED ON )
# set( Boost_DETAILED_FAILURE_MSG   ON )
# set( Boost_DEBUG ON )
# set( Boost_NO_SYSTEM_PATHS ON )

# Client is built only if boost is found; on windows, we need vs10 or higher
# Find Boost on the system, and configure the type of boost build we want
if( NOT DEFINED Boost_USE_STATIC_LIBS )
	set( Boost_USE_STATIC_LIBS   ON )
endif( )

if( NOT DEFINED Boost_USE_STATIC_RUNTIME )
	set( Boost_USE_STATIC_RUNTIME OFF )
endif( )

# This will define Boost_FOUND
find_package( Boost 1.33.0 COMPONENTS program_options )
if( Boost_FOUND )
	message( STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}" )
else( )
	message( WARNING "Try setting Boost_DEBUG and Boost_DETAILED_FAILURE_MSG for more information" )
endif( )

# This will define OPENCL_FOUND
find_package( OpenCL )

# This will define FFTW_FOUND
find_package( FFTW )

# Enable building of the clACML client if both requested and all dependencies are found
if( BUILD_CLIENT AND Boost_FOUND )
	set( FFT_CLIENT ON )
else( )
	set( FFT_CLIENT OFF )
endif( )

# Enable building of the googletest unit test framework if requested and all dependencies are found
set( UNIT_TEST OFF )
if( BUILD_TEST )
	include(gtest.cmake)
	if( GTEST_FOUND AND Boost_FOUND AND FFTW_FOUND )
		set( UNIT_TEST ON )
	else( )
		message( "GoogleTest unit testing will NOT be built" )
	endif( )
endif( )

# Enable building of the callback client if requested and all dependencies are found
if( BUILD_CALLBACK_CLIENT AND Boost_FOUND AND FFTW_FOUND )
	set( FFT_CALLBACK_CLIENT ON )
else( )
	set( FFT_CALLBACK_CLIENT OFF )
endif( )

# FFLAGS depend on the compiler, grab the compiler name from the path
get_filename_component( C_COMPILER_NAME ${CMAKE_C_COMPILER} NAME_WE )
# message( "C_COMPILER_NAME: " ${C_COMPILER_NAME} )
# message( "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} )

if( APPLE )
	# avoid warning on newer cmake versions
	set( CMAKE_MACOSX_RPATH 0 )
endif()

# Set common compile and link options
if( MSVC )
	# Following options for nMake
	message( STATUS "Detected MSVS Ver: " ${MSVC_VERSION} )

	# CMake sets huge stack frames for windows, for whatever reason.  We go with compiler default.
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}" )

elseif( CMAKE_COMPILER_IS_GNUCXX )
	message( STATUS "Detected GNU fortran compiler." )
	EXEC_PROGRAM( ${CMAKE_CXX_COMPILER} ARGS --version OUTPUT_VARIABLE vnum )
	STRING( REGEX REPLACE ".*([0-9])\\.([0-9])\\.([0-9]).*" "\\1\\2\\3" vnum ${vnum} )
	if( ${vnum} STREQUAL "452" )
		# we only want c++0x if we're using gcc 4.5.2
		set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	endif( )

	set( CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}" )
	set( CMAKE_C_FLAGS "-pthread ${CMAKE_C_FLAGS}" )

	# For linux debug builds, define the same preprocessing symbols as win to keep it simple
	if( CMAKE_BUILD_TYPE MATCHES "Debug" )
		add_definitions( "/D_DEBUG" )
	endif( )

	if( BUILD64 )
		set( CMAKE_CXX_FLAGS "-m64 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m64 ${CMAKE_C_FLAGS}" )
	else( )
		set( CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}" )
	endif( )

	if( CODE_COVERAGE )
		set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
		set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
	endif( )
endif( )

# If UNICODE is defined for microsoft compilers, pass extra definitions
if( MSVC AND UNICODE )
	add_definitions( "/DUNICODE /D_UNICODE" )
endif( )

# Print out compiler flags for viewing/debug
message( STATUS "CMAKE_CXX_COMPILER flags: " ${CMAKE_CXX_FLAGS} )
message( STATUS "CMAKE_CXX_COMPILER debug flags: " ${CMAKE_CXX_FLAGS_DEBUG} )
message( STATUS "CMAKE_CXX_COMPILER release flags: " ${CMAKE_CXX_FLAGS_RELEASE} )
message( STATUS "CMAKE_CXX_COMPILER relwithdebinfo flags: " ${CMAKE_CXX_FLAGS_RELWITHDEBINFO} )
message( STATUS "CMAKE_EXE_LINKER link flags: " ${CMAKE_EXE_LINKER_FLAGS} )

if( NOT BUILD_SHARED_LIBS )
	set( CLFFT_STATIC ON )
endif( )
# configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
configure_file( "${PROJECT_SOURCE_DIR}/include/clFFT.version.h.in" "${PROJECT_BINARY_DIR}/include/clFFT.version.h" )
install( FILES
		"${PROJECT_BINARY_DIR}/include/clFFT.version.h"
		"include/clFFT.h"
		"include/clAmdFft.h"
		"include/clAmdFft.version.h"
	DESTINATION
		"./include" )

# Recurse into subdirectory and start building files there
if( BUILD_RUNTIME AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/library" )
	add_subdirectory( library )
else( )
	message( "Runtime library will NOT be built" )
endif( )

if( IS_DIRECTORY "${PROJECT_SOURCE_DIR}/scripts/perf" )
	add_subdirectory( scripts/perf )
endif( )

# We only want to build the following if the user options are set
if( FFT_CLIENT AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/client" )
	add_subdirectory( client )
else( )
	message( "FFT clients will NOT be built" )
endif( )

# Recurse into subdirectory and start building files there
if( BUILD_LOADLIBRARIES AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/statTimer" )
	add_subdirectory( statTimer )
else( )
	message( "LoadLibraries will NOT be built" )
endif( )

if( UNIT_TEST AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/tests" )
	# enable_testing( )
	add_subdirectory( tests )
else( )
	message( "GoogleTest unit tests will NOT be built" )
endif( )

# We only want to build the following if the user options are set
if( FFT_CALLBACK_CLIENT AND IS_DIRECTORY "${PROJECT_SOURCE_DIR}/callback-client" )
	add_subdirectory( callback-client )
else( )
	message( "FFT callback client will NOT be built" )
endif( )

if( BUILD_EXAMPLES )
	add_subdirectory( examples )
endif( )

if( WIN32 )
	set( destdir CMake )
else( )
	set( destdir lib${SUFFIX_LIB}/cmake/clFFT )
endif( )
string( REGEX REPLACE "[^/]+" ".." reldir "${destdir}" )
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfigVersion.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake
	@ONLY )
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/clFFTConfig.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/clFFTConfig.cmake
	@ONLY )
install( EXPORT Library DESTINATION ${destdir} FILE clFFTTargets.cmake )
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/clFFTConfigVersion.cmake
	${CMAKE_CURRENT_BINARY_DIR}/clFFTConfig.cmake
	DESTINATION ${destdir} )

=== src/callback-client/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


#  client
set( Client.Source	callback-client.cpp
                    openCL.misc.cpp
                    stdafx.cpp )

set( Client.Headers client.h
                    openCL.misc.h
                    ../statTimer/statisticalTimer.extern.h
                    ../include/unicode.compatibility.h
                    ../include/stdafx.h
                    ../include/targetver.h
                    ../include/clFFT.h )

set( Client.Files ${Client.Source} ${Client.Headers} )

set( DL_LIB "" )
if( WIN32 )
	add_definitions( "/D_CONSOLE" )
elseif( APPLE )
	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )
else( )
	# To use the dlopen() and dlclose() functions, we should link with libdl
	set( DL_LIB "-ldl -lrt" )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS} ${FFTW_INCLUDE_DIRS} ../../../common ${PROJECT_BINARY_DIR}/include ../include )

add_executable( clFFT-callback-client ${Client.Files} )

target_link_libraries( clFFT-callback-client clFFT ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${FFTW_LIBRARIES} ${DL_LIB} )

set_target_properties( clFFT-callback-client PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( clFFT-callback-client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
if( APPLE )
    # properly deal with RPATH on mac
    set_target_properties( clFFT-callback-client PROPERTIES INSTALL_RPATH "@loader_path/../lib${SUFFIX_LIB}")
endif()

install( TARGETS clFFT-callback-client
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

=== src/client/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


#  client
set( Client.Source	client.cpp
                    openCL.misc.cpp
                    stdafx.cpp )

set( Client.Headers client.h
                    openCL.misc.h
                    ../statTimer/statisticalTimer.extern.h
                    ../include/unicode.compatibility.h
                    ../include/stdafx.h
                    ../include/targetver.h
                    ../include/clFFT.h )

set( Client.Files ${Client.Source} ${Client.Headers} )

set( RT_LIB "" )
if( WIN32 )
	add_definitions( "/D_CONSOLE" )
elseif( NOT APPLE )
	# To use the dlopen() and dlclose() functions, we should link with libdl
	set( RT_LIB "-lrt" )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS} ../../../common ${PROJECT_BINARY_DIR}/include ../include )

add_executable( clFFT-client ${Client.Files} )

target_link_libraries( clFFT-client clFFT ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS} ${RT_LIB} )

set_target_properties( clFFT-client PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( clFFT-client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
if( APPLE )
    # properly deal with RPATH on mac
    set_target_properties( clFFT-client PROPERTIES INSTALL_RPATH "@loader_path/../lib${SUFFIX_LIB}")
endif()

install( TARGETS clFFT-client
        RUNTIME DESTINATION bin${SUFFIX_BIN}
        LIBRARY DESTINATION lib${SUFFIX_LIB}
        ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
        )

=== src/examples/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

INCLUDE_DIRECTORIES(
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${OPENCL_INCLUDE_DIRS}"
    "${PROJECT_SOURCE_DIR}/include"
    "${PROJECT_BINARY_DIR}/include"
    )

LINK_DIRECTORIES("${PROJECT_BINARY_DIR}/package/lib${SUFFIX_LIB}")

FILE(GLOB FILES "*.c")

FOREACH(FILE ${FILES})

    if( MSVC )
    	if( MSVC_VERSION LESS 1800 )
    		# Use C++ with Microsoft compiler
    		SET_SOURCE_FILES_PROPERTIES( ${FILE} PROPERTIES LANGUAGE CXX)
    	endif ()
    endif( )

    GET_FILENAME_COMPONENT(EXAMPLE ${FILE} NAME_WE)
    GET_FILENAME_COMPONENT(FULL_DIR_NAME ${FILE} PATH)
    GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
    SET(EXAMPLE_NAME example_${DIR_NAME}_${EXAMPLE})
    ADD_EXECUTABLE(${EXAMPLE_NAME} ${FILE})

    TARGET_LINK_LIBRARIES(${EXAMPLE_NAME} clFFT ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS})

    SET_TARGET_PROPERTIES(${EXAMPLE_NAME}
        PROPERTIES
        OUTPUT_NAME ${EXAMPLE}
        RUNTIME_OUTPUT_DIRECTORY ${DIR_NAME})

    INSTALL(FILES ${FILE} DESTINATION "share/clFFT/examples")
    INSTALL(TARGETS ${EXAMPLE_NAME}
        RUNTIME DESTINATION "share/clFFT/examples")
ENDFOREACH()

=== src/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


# List the names of the files to compile
set( clFFT.Test.Source
	 test_constants.cpp
	 buffer_memory.cpp
	 buffer.cpp
	 unit_test.cpp
	 accuracy_test_common.cpp
	 accuracy_test_pow2.cpp
	 accuracy_test_pow3.cpp
	 accuracy_test_pow5.cpp
	 accuracy_test_pow7.cpp
	 accuracy_test_mixed_radices.cpp
	 accuracy_test_random.cpp
	 accuracy_test_directed.cpp
	 accuracy_test_mixed_callback.cpp
	 accuracy_test_pow2_precallback.cpp
	 accuracy_test_pow3_precallback.cpp
	 accuracy_test_pow5_precallback.cpp
	 accuracy_test_pow7_precallback.cpp
	 accuracy_test_postcallback.cpp
	 gtest_main.cpp
	 ${PROJECT_SOURCE_DIR}/client/openCL.misc.cpp
	 c-compliance.c
   )

set( clFFT.Test.Headers
	${PROJECT_SOURCE_DIR}/include/clFFT.h
	${PROJECT_SOURCE_DIR}/include/unicode.compatibility.h
	${PROJECT_SOURCE_DIR}/include/convenienceFunctions.h
	${PROJECT_SOURCE_DIR}/library/private.h
	${PROJECT_SOURCE_DIR}/client/openCL.misc.h
	accuracy_test_common.h
	test_constants.h
	buffer_memory.h
	buffer.h
	cl_transform.h
	fftw_transform.h
	typedefs.h
  )

set( clFFT.Test.Files ${clFFT.Test.Source} ${clFFT.Test.Headers} )

set( LD_PTHREAD "" )
if( MINGW )
    # -std=c++0x causes g++ to go into strict ANSI mode, which doesn't declare non-standard functions
    # Googletest for mingw appears to have a dependency on _stricmp and off64_t
	set( CMAKE_CXX_FLAGS "-std=gnu++0x ${CMAKE_CXX_FLAGS}" )
elseif( CMAKE_COMPILER_IS_GNUCXX )
	set( CMAKE_CXX_FLAGS "-std=c++0x ${CMAKE_CXX_FLAGS}" )
	set( LD_PTHREAD "-lpthread" )
elseif( APPLE )
	set( CMAKE_CXX_FLAGS "-std=c++11 -stdlib=libc++ ${CMAKE_CXX_FLAGS}" )
	add_definitions( -DGTEST_USE_OWN_TR1_TUPLE )
endif( )

# Include standard OpenCL headers
include_directories( ${Boost_INCLUDE_DIRS} ${GTEST_INCLUDE_DIRS} ${FFTW_INCLUDE_DIRS} ${OPENCL_INCLUDE_DIRS}  ${PROJECT_BINARY_DIR}/include ${PROJECT_SOURCE_DIR}/include )

add_executable( Test ${clFFT.Test.Files} )

# If the runtime is being built by the project, use it, otherwise link to a runtime library specified in the install prefix
if( BUILD_RUNTIME )
	target_link_libraries( Test clFFT ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} ${CMAKE_DL_LIBS})
else( )
	# Search for 64bit libs if FIND_LIBRARY_USE_LIB64_PATHS is set to true in the global environment, 32bit libs else
	get_property( LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS )
	if( LIB64 )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib64" )
	else( )
		set( clFFT.library "${CMAKE_INSTALL_PREFIX}/lib32" )
	endif( )

	if( WIN32 )
		set( clFFT.library "${clFFT.library}/import/clFFT${CMAKE_STATIC_LIBRARY_SUFFIX}" )
	else( )
		set( clFFT.library "${clFFT.library}/${CMAKE_SHARED_LIBRARY_PREFIX}clFFT${CMAKE_SHARED_LIBRARY_SUFFIX}" )
	endif( )

	target_link_libraries( Test ${clFFT.library} ${Boost_LIBRARIES} ${GTEST_LIBRARIES} ${FFTW_LIBRARIES} ${OPENCL_LIBRARIES} ${LD_PTHREAD} ${CMAKE_DL_LIBS})

endif( )

# The following set_target_properties is to get around a bug in cmake 2.8.2, where the suffix after the first '.' is dropped
IF( (MSVC_VERSION VERSION_EQUAL 1600) AND (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION} VERSION_LESS 2.8.3) )
	message( STATUS "Detected vs2010 and Cmake version less than 2.8.3; renaming Test with underscores " )
	set_target_properties( Test PROPERTIES OUTPUT_NAME "clFFT_Test" )
ENDIF( )

set_target_properties( Test PROPERTIES VERSION ${CLFFT_VERSION} )
set_target_properties( Test PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

=== src/scripts/perf/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(GRAPHING_SCRIPTS 	measurePerformance.py 
						plotPerformance.py 
						fftPerformanceTesting.py 
						errorHandler.py 
						performanceUtility.py
						)
# if( WIN32 )
# 	install( FILES ${GRAPHING_SCRIPTS} DESTINATION bin${SUFFIX_BIN} )
# else ( )
# 	install( FILES ${GRAPHING_SCRIPTS} DESTINATION share/clFFT )
# endif( )

=== debian/changelog ===
clfft (2.12.2-7) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest to work with CMake 4

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Sep 2025 22:27:16 +0200

clfft (2.12.2-6) unstable; urgency=medium

  * Team upload.
  * Bump CMake policy version (Closes: #1112789)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 22:29:57 +0200

clfft (2.12.2-5) unstable; urgency=medium

  * Team upload.
  * No longer call upstream build system install for --arch-all

 -- tony mancill <tmancill@debian.org>  Thu, 28 Sep 2023 07:39:01 -0700

clfft (2.12.2-4) unstable; urgency=medium

  * Team upload

  [ Jonathan Bergh ]
  * Apply reproducibility patch (Closes: #1003375)

  [ tony mancill ]
  * Update doc-base for actually install directory (libclfft-dev)
  * Set Rules-Requires-Root: no in debian/control
  * Use debhelper-compat 13
  * Bump Standards-Version to 4.6.2 (no changes)

 -- tony mancill <tmancill@debian.org>  Thu, 28 Sep 2023 06:10:19 -0700

clfft (2.12.2-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -fpermissive to workaround FTBFS with gcc 11.
    (Closes: #997197)

 -- Adrian Bunk <bunk@debian.org>  Thu, 06 Jan 2022 14:09:04 +0200

clfft (2.12.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/tests/build-examples: Fix path of examples after debhelper compat
    bump (Closes: #978002)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 10 Jan 2021 20:36:30 +0100

clfft (2.12.2-3) unstable; urgency=medium

  [ Anton Gladky ]
  * Team upload.
  * [c5c7aac] Add .gitlab-ci.yml
  * [58d881f] Update watch file format version to 4.
  * [fa9a95f] Bump debhelper from deprecated 9 to 12.
  * [fbede47] Set debhelper-compat version in Build-Depends.
  * [fc3f0e6] Set field Upstream-Contact in debian/copyright.
  * [b3eee1b] Set upstream metadata fields: Repository.
  * [2a7b81f] Update Vcs-* headers from URL redirect.
  * [d60c190] Use canonical URL in Vcs-Git.
  * [360f610] Drop unnecessary dh arguments: --parallel
  * [4c183bb] Remove obsolete fields Contact, Name from debian/upstream/metadata
  * [6999aaf] Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.
  * [085b994] Set Standards-Version 4.5.0. No changes

  [ Chris Lamb ]
  * [edf7325] Make the build reproducible. (Closes: #891075)

 -- Anton Gladky <gladk@debian.org>  Tue, 08 Dec 2020 20:41:18 +0100

clfft (2.12.2-2) UNRELEASED; urgency=medium

  * Remove unnecessary 'Testsuite: autopkgtest' header.
  * Trim trailing whitespace.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 20 Oct 2018 13:41:22 +0000

clfft (2.12.2-1) unstable; urgency=medium

  * New upstream release.
  * Update patch queue.
    - Refresh disable-multilib-cflags.patch.
    - Drop obsolete use-boost-dynamic-libs.patch.
  * Use Boost dynamic libraries via CMake options.
  * Rename package libclfft-bin to clfft-client.
  * Update description of binary packages.
  * Add missing Multi-Arch field for -dev and -doc.
  * Disable build of examples.
  * Minor enhancements to rules file.
    - Clear superfluous comments.
    - Wrap, sort and format.
  * Use HTTPS for Format field in copyright file.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 01 Sep 2016 13:29:32 +0100

=== debian/control ===
Source: clfft
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
           Jerome Kieffer <jerome.kieffer@esrf.fr>,
           Jonathan Bergh <bergh.jonathan@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/clfft
Vcs-Git: https://salsa.debian.org/science-team/clfft.git
Homepage: https://github.com/clMathLibraries/clFFT
Rules-Requires-Root: no

Package: libclfft2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL FFT library
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the shared library.

Package: libclfft-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libclfft2 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: libclfft-doc
Description: development files for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the development files.

Package: libclfft-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the documentation.

Package: clfft-client
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclfft2 (= ${binary:Version})
Breaks: libclfft-bin (<< 2.12.2-1)
Provides: libclfft-bin
Replaces: libclfft-bin (<< 2.12.2-1)
Description: client program for clFFT
 The clFFT library is an open source OpenCL library implementation of discrete
 Fast Fourier Transforms, which:
 .
   * Provides a fast and accurate platform for calculating discrete FFTs.
   * Works on CPU or GPU backends.
   * Supports in-place or out-of-place transforms.
   * Supports 1D, 2D, and 3D transforms with a batch size that can be greater
     than 1.
   * Supports planar (real and complex components in separate arrays) and
     interleaved (real and complex components as a pair contiguous in memory)
     formats.
   * Supports dimension lengths that can be any mix of powers of 2, 3, and 5.
   * Supports single and double precision floating point formats.
 .
 This package provides the client program.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -fpermissive
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILD_OPTIONS = \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.10 \
	-DBoost_USE_STATIC_LIBS=OFF \
	-DBUILD_CLIENT=ON \
	-DBUILD_EXAMPLES=OFF \
	-DBUILD_LOADLIBRARIES=OFF \
	-DBUILD_RUNTIME=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TEST=OFF \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DSUFFIX_LIB="/$(DEB_TARGET_MULTIARCH)"

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build-indep:
	cd docs && doxygen clFFT.doxy

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

override_dh_auto_install-indep:
	# nothing to do here
	#
	# dh-compat 13 invokes this target, which invokes cmake install resulting
	# in a build failure when building with "--arch-all --no-arch-any"
	# Documentation is installed via other targets anyway.

=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libclfft-dev,
         libclfft-doc
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clFFT-$1\.tar\.gz/ https://github.com/clMathLibraries/clFFT/tags .*/v?(\d\S*)\.tar\.gz
